\\ Copyright 2014 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

read("pol-pfrac.gp");

sqrt3i = quadgen(-3 *4);
b=1+I;


\\-----------------------------------------------------------------------------
str_poly_ascending__join_strings(v,sep) =
{
  concat(vector(2*#v-1,i, if(i%2,v[(i+1)\2],sep)));
}

str_poly_ascending(p) =
{
  if(type(p) == "t_VEC",
     return(str_poly_ascending__join_strings(apply(str_poly_ascending,p),
                                             "\n + ")));

  my(d = denominator(p));
  if(poldegree(d) != 0,
     p = numerator(p);
     my(low = polcoeff(d, 0));
     if(low==0, error("Oops, constant term of denominator is 0"));
     d /= low;
     p /= low;
     my(p_single = (poldegree(p) == 0
                    || poldegree(p) == valuation(p,variable(p))));
     my(d_single = (poldegree(d) == 0
                    || poldegree(d) == valuation(d,variable(d))));
     p_single = 0;
     d_single = 0;
     return(concat([if(p_single,"","("),
                    str_poly_ascending(p),
                    if(p_single,"",")"),
                    "/",
                    if(d_single,"","("),
                    str_poly_ascending(d),
                    if(d_single,"",")")
                   ])));
  if(poldegree(p) <= 0, return(Str(p)));
  my(str="");
  for(i=0,poldegree(p),
     my(coeff=polcoeff(p,i));
     if(coeff == 0, next());
     if(str!="",
        if(real(coeff)<0 || (real(coeff)==0 && imag(coeff)<0),
           str=concat(str," - "); coeff = -coeff,
           str=concat(str," + ")));
     str = concat([str,coeff*variable(p)^i]));
  str;
}

\\ str = str_poly_ascending( (x^2 + 1/2*x + 1)/(2*x^3 + x - 1) );
\\ print("str = "str);
\\ 
\\ str = str_poly_ascending( ((-1/4 + 1/4*I)*x^2 + (1/8 + 1/8*I))/(x^3 - 1/4*I*x + (1/8 + 1/8*I)) );
\\ print("str = "str);
\\ 
\\ str = str_poly_ascending( (x^2)/(2*x^3 + x - 1) );
\\ print("str = "str);

\\-----------------------------------------------------------------------------

p = (-8*I*x^6 + (-2 + 2*I)*x^5 + (5 - 3*I)*x^3)/(-16*x^6 + (8 - 8*I)*x^5 + (16 + 4*I)*x^4 + (-12 + 4*I)*x^3 + (2 - 4*I)*x^2 + (4 + 4*I)*x - 2);
v = pol_partial_fractions(p);
print("v="v);
print(str_poly_ascending(v));
quit


print("gGRN");
p = ((-16 - 16*I)*x^7 - 24*x^6 + (10 + 6*I)*x^5 + (-8 - 2*I)*x^4 + (3 - I)*x^3 + (-1 + 2*I)*x^2 + (-1 - I)*x + 1)/(32*x^8 + (-48 + 16*I)*x^7 - 24*I*x^6 + (48 + 8*I)*x^5 + (-44 + 12*I)*x^4 + (8 - 20*I)*x^3 + (10 + 12*I)*x^2 + (-8 - 4*I)*x + 2);
print("p=" p);
print("p=" str_poly_ascending(p));
print("");
v = pol_partial_fractions(p);
print("v="v);
print(str_poly_ascending(v));
quit


print("gGRQN");
gLQ(x) = (1 + x^2) / (1 - x - 2*x^3);
gGRQN(x) = -1/2 \
  + (1-1/2*I)*1/(1-x) \
  + x*(1+1/2*I)*1/(1-x)*gLQ(b*x);
p = gGRQN(x);
print("p=" p);
print("p=" str_poly_ascending(p));
print("");
v = pol_partial_fractions(gGRQN(x));
print("v="v);
print(str_poly_ascending(v));
quit


{
p =    1/2*I
         + (-21/164 - 57/164*I)  /(1 - x)
         + (1/20 - 3/20*I) /(1 + x)
         + (-3/10 - 1/10*I)  /(1 - b*x)

         + (4/41 + 5/41*I)
         * (+ (2 - 3/2*I)
            + (-3/2 + I)  * b*x
            - 1/2         * b^2*x^2
            + 1/2*I       * b^3*x^3
           )
            / ((1-b*x)*(1 - b*x - 2*b^3*x^3 ));
}
print("p="p);
v = pol_partial_fractions(p);
print("v="v);
print(str_poly_ascending(v));
quit

v = pol_partial_fractions(1/((1-x)^6-x^6),     sqrt3i)
print("v="v);
print(str_poly_ascending(v));
quit

v = pol_partial_fractions(x^6/( (1-x)*(1+x) ),  [1+x])
print("v="v);
print();
quit

v = pol_partial_fractions(1/(x+1)^2 + 1/(x+1)^4 + 1/(x+1)^6, [(x+1)^2])
print("v="v);
print();
quit

v = pol_partial_fractions((x^2 + 3*x + 3)/(x+1)^3, [(x+1)^2] )
print("v="v);
print();
quit

pol_partial_fractions(1/(x+1) + 1/(x+1)^2 + 1/(x+1)^3, [(x+1)^2])


\\ gA(x)
pol_partial_fractions(x^4, [(1 - x - 2*x^3), (1-x), (1-2*x) ])

pol_partial_fractions(1/( (1+x-x^2)*(1+x) ))
pol_partial_fractions( (x^4+1)/( (1-x)^5 ))
quit




\\ pol_partial_fractions( 1/( (x+1)*(x+2)*(x+3)*(x+4) ),  [ x+4 ] )

\\ (A+B*x) / ((x+1)*(x+2)) + C/(x+4) == ((4*A + 2*C) + (A + 4*B + 3*C)*x + (B + C)*x^2) / (x^3 + 7*x^2 + 14*x + 8)
\\ (A+B*x)*(x+4) + C*((x+1)*(x+2))   ==  (4*A + 2*C) + (A + 4*B + 3*C)*x + (B + C)*x^2
\\ matsolve([4,0,2; 1,4,3; 0,1,1],[1,0,0]~) == [1/6, -1/6, 1/6]~
\\ 4,0,2    1, 4, 3    1, 4, 3
\\ 1,4,3    0,-1,-7    0, 1, 7
\\ 0,1,1    0, 1, 1    0, 0, 1
\\[4, 4, 2;
\\ 1, 1, 3;
\\ 0, 0, 1]
\\ pol_partial_fractions( 1/( (x+1)*(x+2)*(x+4) ),  [ x+4 ] )

\\ pol_partial_fractions(1, [1+2*x, 3+4*x])
\\ \\ pol_partial_fractions(1, [1-x, 1+x, 2+x, 1-2*x])
\\ 
\\ print("");
\\ print("");
\\ 
\\ \\ gR(x)
\\ pol_partial_fractions((1 + x^2 + 2*x^4), [(1-x), (1 - x - 2*x^3)])
\\ 
\\ A/(x-1) + B/(x-1)^2 + C/(x-1)^3 == ( A*x^2 + (-2*A + B)*x  +  (A  -B +C) )/(x^3 - 3*x^2 + 3*x - 1)
\\ {
\\   pol_partial_fractions(1, [(x-1),
\\                         (x-1),
\\                        (1 - x - 2*x^3)])
\\ }

{
  f = 1/4*(-1/2 + 1/2*I)*((-32 + 32*I)*x^7 - 16*x^6 + (16 + 8*I)*x^5 + (-14 + 14*I)*x^4 - 2*x^3 + (1 - I)*x^2 + I*x - 1)
     /
     (
        (1+x)
      * ((1/2+1/2*I) - x)
      * ((1/2-1/2*I) - x)
      * ((1/2-1/2*I) - x)
      * (1 - b*x - 2*b^3*x^3)
     );
  factor(f)

\\   pol_partial_fractions(f,
\\                         [ (1+x),
\\                      (b/2 - x),
\\                      (conj(b)/2 - x),
\\                      (conj(b)/2 - x),
\\                      (1 - b*x - 2*b^3*x^3)
\\                     ])
}

\\ \\ pol_partial_fractions( 1/( (x-I*2)*(x+I*3) ) )
\\ pol_partial_fractions( 1/( (x^2+3) ), [x - sqrt3i, x + sqrt3i] )
\\ pol_partial_fractions( sqrt3i/(x^2 + 1) )
\\ pol_partial_fractions( 1/(x^2 + 9) )
\\ pol_partial_fractions( sqrt3i/((1-x)^6 - x^6) )

\\ pol_partial_fractions( x^2*(1-x)^3 / ((1-2*x)*(1-x+x^2)*(1-3*x+3*x^2))*sqrt3i )

gL(x) = -1 + (2 + 2*x^2) / (1 - x - 2*x^3);
\\ pol_partial_fractions( b*x/(1-x) *gL(b*x) )
\\ pol_partial_fractions( - x*I/(1-x) * (-1/2 + I) )
pol_partial_fractions( ( (8       ) + (39       )*r + (25       )*r^2 )/82/ (r - (-1 - sqrt3i)/2)/ (r - (-1 + sqrt3i)/2))

gJA(x) = 1/2*( - 1/(1-x) + 1/(1-x-2*x^3) );
{
pol_partial_fractions(  
(10*x^4 - 8*x^3 + 6*x^2 - 10*x + 4)/(-4*x^5 + 6*x^4 - 4*x^3 + 5*x^2 - 4*x + 1)
)
}
